package org.xtext.example.mydsl.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.mydsl.services.PEnumGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalPEnumParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_STRING", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'enum'", "'{'", "'}'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_STRING=5;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__13=13;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=6;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

    // delegates
    // delegators


        public InternalPEnumParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalPEnumParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalPEnumParser.tokenNames; }
    public String getGrammarFileName() { return "../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g"; }



     	private PEnumGrammarAccess grammarAccess;
     	
        public InternalPEnumParser(TokenStream input, PEnumGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "Model";	
       	}
       	
       	@Override
       	protected PEnumGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleModel"
    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:67:1: entryRuleModel returns [EObject current=null] : iv_ruleModel= ruleModel EOF ;
    public final EObject entryRuleModel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModel = null;


        try {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:68:2: (iv_ruleModel= ruleModel EOF )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:69:2: iv_ruleModel= ruleModel EOF
            {
             newCompositeNode(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_ruleModel_in_entryRuleModel75);
            iv_ruleModel=ruleModel();

            state._fsp--;

             current =iv_ruleModel; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleModel85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:76:1: ruleModel returns [EObject current=null] : ( (lv_penums_0_0= rulePEnum ) )* ;
    public final EObject ruleModel() throws RecognitionException {
        EObject current = null;

        EObject lv_penums_0_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:79:28: ( ( (lv_penums_0_0= rulePEnum ) )* )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:80:1: ( (lv_penums_0_0= rulePEnum ) )*
            {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:80:1: ( (lv_penums_0_0= rulePEnum ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:81:1: (lv_penums_0_0= rulePEnum )
            	    {
            	    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:81:1: (lv_penums_0_0= rulePEnum )
            	    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:82:3: lv_penums_0_0= rulePEnum
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getModelAccess().getPenumsPEnumParserRuleCall_0()); 
            	    	    
            	    pushFollow(FOLLOW_rulePEnum_in_ruleModel130);
            	    lv_penums_0_0=rulePEnum();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getModelRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"penums",
            	            		lv_penums_0_0, 
            	            		"PEnum");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRulePEnum"
    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:106:1: entryRulePEnum returns [EObject current=null] : iv_rulePEnum= rulePEnum EOF ;
    public final EObject entryRulePEnum() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePEnum = null;


        try {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:107:2: (iv_rulePEnum= rulePEnum EOF )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:108:2: iv_rulePEnum= rulePEnum EOF
            {
             newCompositeNode(grammarAccess.getPEnumRule()); 
            pushFollow(FOLLOW_rulePEnum_in_entryRulePEnum166);
            iv_rulePEnum=rulePEnum();

            state._fsp--;

             current =iv_rulePEnum; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePEnum176); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePEnum"


    // $ANTLR start "rulePEnum"
    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:115:1: rulePEnum returns [EObject current=null] : (otherlv_0= 'enum' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_elements_3_0= rulePEnumElement ) )* otherlv_4= '}' ) ;
    public final EObject rulePEnum() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_elements_3_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:118:28: ( (otherlv_0= 'enum' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_elements_3_0= rulePEnumElement ) )* otherlv_4= '}' ) )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:119:1: (otherlv_0= 'enum' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_elements_3_0= rulePEnumElement ) )* otherlv_4= '}' )
            {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:119:1: (otherlv_0= 'enum' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_elements_3_0= rulePEnumElement ) )* otherlv_4= '}' )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:119:3: otherlv_0= 'enum' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_elements_3_0= rulePEnumElement ) )* otherlv_4= '}'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_11_in_rulePEnum213); 

                	newLeafNode(otherlv_0, grammarAccess.getPEnumAccess().getEnumKeyword_0());
                
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:123:1: ( (lv_name_1_0= RULE_ID ) )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:124:1: (lv_name_1_0= RULE_ID )
            {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:124:1: (lv_name_1_0= RULE_ID )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:125:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePEnum230); 

            			newLeafNode(lv_name_1_0, grammarAccess.getPEnumAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPEnumRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_rulePEnum247); 

                	newLeafNode(otherlv_2, grammarAccess.getPEnumAccess().getLeftCurlyBracketKeyword_2());
                
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:145:1: ( (lv_elements_3_0= rulePEnumElement ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==RULE_ID) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:146:1: (lv_elements_3_0= rulePEnumElement )
            	    {
            	    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:146:1: (lv_elements_3_0= rulePEnumElement )
            	    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:147:3: lv_elements_3_0= rulePEnumElement
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getPEnumAccess().getElementsPEnumElementParserRuleCall_3_0()); 
            	    	    
            	    pushFollow(FOLLOW_rulePEnumElement_in_rulePEnum268);
            	    lv_elements_3_0=rulePEnumElement();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getPEnumRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"elements",
            	            		lv_elements_3_0, 
            	            		"PEnumElement");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            otherlv_4=(Token)match(input,13,FOLLOW_13_in_rulePEnum281); 

                	newLeafNode(otherlv_4, grammarAccess.getPEnumAccess().getRightCurlyBracketKeyword_4());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePEnum"


    // $ANTLR start "entryRulePEnumElement"
    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:175:1: entryRulePEnumElement returns [EObject current=null] : iv_rulePEnumElement= rulePEnumElement EOF ;
    public final EObject entryRulePEnumElement() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePEnumElement = null;


        try {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:176:2: (iv_rulePEnumElement= rulePEnumElement EOF )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:177:2: iv_rulePEnumElement= rulePEnumElement EOF
            {
             newCompositeNode(grammarAccess.getPEnumElementRule()); 
            pushFollow(FOLLOW_rulePEnumElement_in_entryRulePEnumElement317);
            iv_rulePEnumElement=rulePEnumElement();

            state._fsp--;

             current =iv_rulePEnumElement; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePEnumElement327); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePEnumElement"


    // $ANTLR start "rulePEnumElement"
    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:184:1: rulePEnumElement returns [EObject current=null] : ( ( (lv_name_0_0= RULE_ID ) ) ( (lv_alternateText_1_0= RULE_STRING ) )? ) ;
    public final EObject rulePEnumElement() throws RecognitionException {
        EObject current = null;

        Token lv_name_0_0=null;
        Token lv_alternateText_1_0=null;

         enterRule(); 
            
        try {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:187:28: ( ( ( (lv_name_0_0= RULE_ID ) ) ( (lv_alternateText_1_0= RULE_STRING ) )? ) )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:188:1: ( ( (lv_name_0_0= RULE_ID ) ) ( (lv_alternateText_1_0= RULE_STRING ) )? )
            {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:188:1: ( ( (lv_name_0_0= RULE_ID ) ) ( (lv_alternateText_1_0= RULE_STRING ) )? )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:188:2: ( (lv_name_0_0= RULE_ID ) ) ( (lv_alternateText_1_0= RULE_STRING ) )?
            {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:188:2: ( (lv_name_0_0= RULE_ID ) )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:189:1: (lv_name_0_0= RULE_ID )
            {
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:189:1: (lv_name_0_0= RULE_ID )
            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:190:3: lv_name_0_0= RULE_ID
            {
            lv_name_0_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePEnumElement369); 

            			newLeafNode(lv_name_0_0, grammarAccess.getPEnumElementAccess().getNameIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPEnumElementRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_0_0, 
                    		"ID");
            	    

            }


            }

            // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:206:2: ( (lv_alternateText_1_0= RULE_STRING ) )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==RULE_STRING) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:207:1: (lv_alternateText_1_0= RULE_STRING )
                    {
                    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:207:1: (lv_alternateText_1_0= RULE_STRING )
                    // ../org.xtext.example.penum/src-gen/org/xtext/example/mydsl/parser/antlr/internal/InternalPEnum.g:208:3: lv_alternateText_1_0= RULE_STRING
                    {
                    lv_alternateText_1_0=(Token)match(input,RULE_STRING,FOLLOW_RULE_STRING_in_rulePEnumElement391); 

                    			newLeafNode(lv_alternateText_1_0, grammarAccess.getPEnumElementAccess().getAlternateTextSTRINGTerminalRuleCall_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getPEnumElementRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"alternateText",
                            		lv_alternateText_1_0, 
                            		"STRING");
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePEnumElement"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleModel_in_entryRuleModel75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleModel85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePEnum_in_ruleModel130 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_rulePEnum_in_entryRulePEnum166 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePEnum176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_rulePEnum213 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePEnum230 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_rulePEnum247 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_rulePEnumElement_in_rulePEnum268 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_13_in_rulePEnum281 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePEnumElement_in_entryRulePEnumElement317 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePEnumElement327 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePEnumElement369 = new BitSet(new long[]{0x0000000000000022L});
    public static final BitSet FOLLOW_RULE_STRING_in_rulePEnumElement391 = new BitSet(new long[]{0x0000000000000002L});

}