package org.xtext.example.mydsl.ui.contentassist.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.mydsl.services.PEnumGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalPEnumParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_STRING", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'enum'", "'{'", "'}'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_STRING=5;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__13=13;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=6;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

    // delegates
    // delegators


        public InternalPEnumParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalPEnumParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalPEnumParser.tokenNames; }
    public String getGrammarFileName() { return "../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g"; }


     
     	private PEnumGrammarAccess grammarAccess;
     	
        public void setGrammarAccess(PEnumGrammarAccess grammarAccess) {
        	this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected Grammar getGrammar() {
        	return grammarAccess.getGrammar();
        }
        
        @Override
        protected String getValueForTokenName(String tokenName) {
        	return tokenName;
        }




    // $ANTLR start "entryRuleModel"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:60:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:61:1: ( ruleModel EOF )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:62:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_ruleModel_in_entryRuleModel61);
            ruleModel();

            state._fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleModel68); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:69:1: ruleModel : ( ( rule__Model__PenumsAssignment )* ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:73:2: ( ( ( rule__Model__PenumsAssignment )* ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:74:1: ( ( rule__Model__PenumsAssignment )* )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:74:1: ( ( rule__Model__PenumsAssignment )* )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:75:1: ( rule__Model__PenumsAssignment )*
            {
             before(grammarAccess.getModelAccess().getPenumsAssignment()); 
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:76:1: ( rule__Model__PenumsAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:76:2: rule__Model__PenumsAssignment
            	    {
            	    pushFollow(FOLLOW_rule__Model__PenumsAssignment_in_ruleModel94);
            	    rule__Model__PenumsAssignment();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getModelAccess().getPenumsAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRulePEnum"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:88:1: entryRulePEnum : rulePEnum EOF ;
    public final void entryRulePEnum() throws RecognitionException {
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:89:1: ( rulePEnum EOF )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:90:1: rulePEnum EOF
            {
             before(grammarAccess.getPEnumRule()); 
            pushFollow(FOLLOW_rulePEnum_in_entryRulePEnum122);
            rulePEnum();

            state._fsp--;

             after(grammarAccess.getPEnumRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRulePEnum129); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePEnum"


    // $ANTLR start "rulePEnum"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:97:1: rulePEnum : ( ( rule__PEnum__Group__0 ) ) ;
    public final void rulePEnum() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:101:2: ( ( ( rule__PEnum__Group__0 ) ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:102:1: ( ( rule__PEnum__Group__0 ) )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:102:1: ( ( rule__PEnum__Group__0 ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:103:1: ( rule__PEnum__Group__0 )
            {
             before(grammarAccess.getPEnumAccess().getGroup()); 
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:104:1: ( rule__PEnum__Group__0 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:104:2: rule__PEnum__Group__0
            {
            pushFollow(FOLLOW_rule__PEnum__Group__0_in_rulePEnum155);
            rule__PEnum__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPEnumAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePEnum"


    // $ANTLR start "entryRulePEnumElement"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:116:1: entryRulePEnumElement : rulePEnumElement EOF ;
    public final void entryRulePEnumElement() throws RecognitionException {
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:117:1: ( rulePEnumElement EOF )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:118:1: rulePEnumElement EOF
            {
             before(grammarAccess.getPEnumElementRule()); 
            pushFollow(FOLLOW_rulePEnumElement_in_entryRulePEnumElement182);
            rulePEnumElement();

            state._fsp--;

             after(grammarAccess.getPEnumElementRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRulePEnumElement189); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePEnumElement"


    // $ANTLR start "rulePEnumElement"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:125:1: rulePEnumElement : ( ( rule__PEnumElement__Group__0 ) ) ;
    public final void rulePEnumElement() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:129:2: ( ( ( rule__PEnumElement__Group__0 ) ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:130:1: ( ( rule__PEnumElement__Group__0 ) )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:130:1: ( ( rule__PEnumElement__Group__0 ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:131:1: ( rule__PEnumElement__Group__0 )
            {
             before(grammarAccess.getPEnumElementAccess().getGroup()); 
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:132:1: ( rule__PEnumElement__Group__0 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:132:2: rule__PEnumElement__Group__0
            {
            pushFollow(FOLLOW_rule__PEnumElement__Group__0_in_rulePEnumElement215);
            rule__PEnumElement__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPEnumElementAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePEnumElement"


    // $ANTLR start "rule__PEnum__Group__0"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:146:1: rule__PEnum__Group__0 : rule__PEnum__Group__0__Impl rule__PEnum__Group__1 ;
    public final void rule__PEnum__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:150:1: ( rule__PEnum__Group__0__Impl rule__PEnum__Group__1 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:151:2: rule__PEnum__Group__0__Impl rule__PEnum__Group__1
            {
            pushFollow(FOLLOW_rule__PEnum__Group__0__Impl_in_rule__PEnum__Group__0249);
            rule__PEnum__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__PEnum__Group__1_in_rule__PEnum__Group__0252);
            rule__PEnum__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__0"


    // $ANTLR start "rule__PEnum__Group__0__Impl"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:158:1: rule__PEnum__Group__0__Impl : ( 'enum' ) ;
    public final void rule__PEnum__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:162:1: ( ( 'enum' ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:163:1: ( 'enum' )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:163:1: ( 'enum' )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:164:1: 'enum'
            {
             before(grammarAccess.getPEnumAccess().getEnumKeyword_0()); 
            match(input,11,FOLLOW_11_in_rule__PEnum__Group__0__Impl280); 
             after(grammarAccess.getPEnumAccess().getEnumKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__0__Impl"


    // $ANTLR start "rule__PEnum__Group__1"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:177:1: rule__PEnum__Group__1 : rule__PEnum__Group__1__Impl rule__PEnum__Group__2 ;
    public final void rule__PEnum__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:181:1: ( rule__PEnum__Group__1__Impl rule__PEnum__Group__2 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:182:2: rule__PEnum__Group__1__Impl rule__PEnum__Group__2
            {
            pushFollow(FOLLOW_rule__PEnum__Group__1__Impl_in_rule__PEnum__Group__1311);
            rule__PEnum__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__PEnum__Group__2_in_rule__PEnum__Group__1314);
            rule__PEnum__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__1"


    // $ANTLR start "rule__PEnum__Group__1__Impl"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:189:1: rule__PEnum__Group__1__Impl : ( ( rule__PEnum__NameAssignment_1 ) ) ;
    public final void rule__PEnum__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:193:1: ( ( ( rule__PEnum__NameAssignment_1 ) ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:194:1: ( ( rule__PEnum__NameAssignment_1 ) )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:194:1: ( ( rule__PEnum__NameAssignment_1 ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:195:1: ( rule__PEnum__NameAssignment_1 )
            {
             before(grammarAccess.getPEnumAccess().getNameAssignment_1()); 
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:196:1: ( rule__PEnum__NameAssignment_1 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:196:2: rule__PEnum__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__PEnum__NameAssignment_1_in_rule__PEnum__Group__1__Impl341);
            rule__PEnum__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPEnumAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__1__Impl"


    // $ANTLR start "rule__PEnum__Group__2"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:206:1: rule__PEnum__Group__2 : rule__PEnum__Group__2__Impl rule__PEnum__Group__3 ;
    public final void rule__PEnum__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:210:1: ( rule__PEnum__Group__2__Impl rule__PEnum__Group__3 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:211:2: rule__PEnum__Group__2__Impl rule__PEnum__Group__3
            {
            pushFollow(FOLLOW_rule__PEnum__Group__2__Impl_in_rule__PEnum__Group__2371);
            rule__PEnum__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__PEnum__Group__3_in_rule__PEnum__Group__2374);
            rule__PEnum__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__2"


    // $ANTLR start "rule__PEnum__Group__2__Impl"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:218:1: rule__PEnum__Group__2__Impl : ( '{' ) ;
    public final void rule__PEnum__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:222:1: ( ( '{' ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:223:1: ( '{' )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:223:1: ( '{' )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:224:1: '{'
            {
             before(grammarAccess.getPEnumAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,12,FOLLOW_12_in_rule__PEnum__Group__2__Impl402); 
             after(grammarAccess.getPEnumAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__2__Impl"


    // $ANTLR start "rule__PEnum__Group__3"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:237:1: rule__PEnum__Group__3 : rule__PEnum__Group__3__Impl rule__PEnum__Group__4 ;
    public final void rule__PEnum__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:241:1: ( rule__PEnum__Group__3__Impl rule__PEnum__Group__4 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:242:2: rule__PEnum__Group__3__Impl rule__PEnum__Group__4
            {
            pushFollow(FOLLOW_rule__PEnum__Group__3__Impl_in_rule__PEnum__Group__3433);
            rule__PEnum__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__PEnum__Group__4_in_rule__PEnum__Group__3436);
            rule__PEnum__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__3"


    // $ANTLR start "rule__PEnum__Group__3__Impl"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:249:1: rule__PEnum__Group__3__Impl : ( ( rule__PEnum__ElementsAssignment_3 )* ) ;
    public final void rule__PEnum__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:253:1: ( ( ( rule__PEnum__ElementsAssignment_3 )* ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:254:1: ( ( rule__PEnum__ElementsAssignment_3 )* )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:254:1: ( ( rule__PEnum__ElementsAssignment_3 )* )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:255:1: ( rule__PEnum__ElementsAssignment_3 )*
            {
             before(grammarAccess.getPEnumAccess().getElementsAssignment_3()); 
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:256:1: ( rule__PEnum__ElementsAssignment_3 )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==RULE_ID) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:256:2: rule__PEnum__ElementsAssignment_3
            	    {
            	    pushFollow(FOLLOW_rule__PEnum__ElementsAssignment_3_in_rule__PEnum__Group__3__Impl463);
            	    rule__PEnum__ElementsAssignment_3();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

             after(grammarAccess.getPEnumAccess().getElementsAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__3__Impl"


    // $ANTLR start "rule__PEnum__Group__4"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:266:1: rule__PEnum__Group__4 : rule__PEnum__Group__4__Impl ;
    public final void rule__PEnum__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:270:1: ( rule__PEnum__Group__4__Impl )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:271:2: rule__PEnum__Group__4__Impl
            {
            pushFollow(FOLLOW_rule__PEnum__Group__4__Impl_in_rule__PEnum__Group__4494);
            rule__PEnum__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__4"


    // $ANTLR start "rule__PEnum__Group__4__Impl"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:277:1: rule__PEnum__Group__4__Impl : ( '}' ) ;
    public final void rule__PEnum__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:281:1: ( ( '}' ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:282:1: ( '}' )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:282:1: ( '}' )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:283:1: '}'
            {
             before(grammarAccess.getPEnumAccess().getRightCurlyBracketKeyword_4()); 
            match(input,13,FOLLOW_13_in_rule__PEnum__Group__4__Impl522); 
             after(grammarAccess.getPEnumAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__Group__4__Impl"


    // $ANTLR start "rule__PEnumElement__Group__0"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:306:1: rule__PEnumElement__Group__0 : rule__PEnumElement__Group__0__Impl rule__PEnumElement__Group__1 ;
    public final void rule__PEnumElement__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:310:1: ( rule__PEnumElement__Group__0__Impl rule__PEnumElement__Group__1 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:311:2: rule__PEnumElement__Group__0__Impl rule__PEnumElement__Group__1
            {
            pushFollow(FOLLOW_rule__PEnumElement__Group__0__Impl_in_rule__PEnumElement__Group__0563);
            rule__PEnumElement__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__PEnumElement__Group__1_in_rule__PEnumElement__Group__0566);
            rule__PEnumElement__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnumElement__Group__0"


    // $ANTLR start "rule__PEnumElement__Group__0__Impl"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:318:1: rule__PEnumElement__Group__0__Impl : ( ( rule__PEnumElement__NameAssignment_0 ) ) ;
    public final void rule__PEnumElement__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:322:1: ( ( ( rule__PEnumElement__NameAssignment_0 ) ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:323:1: ( ( rule__PEnumElement__NameAssignment_0 ) )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:323:1: ( ( rule__PEnumElement__NameAssignment_0 ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:324:1: ( rule__PEnumElement__NameAssignment_0 )
            {
             before(grammarAccess.getPEnumElementAccess().getNameAssignment_0()); 
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:325:1: ( rule__PEnumElement__NameAssignment_0 )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:325:2: rule__PEnumElement__NameAssignment_0
            {
            pushFollow(FOLLOW_rule__PEnumElement__NameAssignment_0_in_rule__PEnumElement__Group__0__Impl593);
            rule__PEnumElement__NameAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getPEnumElementAccess().getNameAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnumElement__Group__0__Impl"


    // $ANTLR start "rule__PEnumElement__Group__1"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:335:1: rule__PEnumElement__Group__1 : rule__PEnumElement__Group__1__Impl ;
    public final void rule__PEnumElement__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:339:1: ( rule__PEnumElement__Group__1__Impl )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:340:2: rule__PEnumElement__Group__1__Impl
            {
            pushFollow(FOLLOW_rule__PEnumElement__Group__1__Impl_in_rule__PEnumElement__Group__1623);
            rule__PEnumElement__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnumElement__Group__1"


    // $ANTLR start "rule__PEnumElement__Group__1__Impl"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:346:1: rule__PEnumElement__Group__1__Impl : ( ( rule__PEnumElement__AlternateTextAssignment_1 )? ) ;
    public final void rule__PEnumElement__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:350:1: ( ( ( rule__PEnumElement__AlternateTextAssignment_1 )? ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:351:1: ( ( rule__PEnumElement__AlternateTextAssignment_1 )? )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:351:1: ( ( rule__PEnumElement__AlternateTextAssignment_1 )? )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:352:1: ( rule__PEnumElement__AlternateTextAssignment_1 )?
            {
             before(grammarAccess.getPEnumElementAccess().getAlternateTextAssignment_1()); 
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:353:1: ( rule__PEnumElement__AlternateTextAssignment_1 )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==RULE_STRING) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:353:2: rule__PEnumElement__AlternateTextAssignment_1
                    {
                    pushFollow(FOLLOW_rule__PEnumElement__AlternateTextAssignment_1_in_rule__PEnumElement__Group__1__Impl650);
                    rule__PEnumElement__AlternateTextAssignment_1();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPEnumElementAccess().getAlternateTextAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnumElement__Group__1__Impl"


    // $ANTLR start "rule__Model__PenumsAssignment"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:368:1: rule__Model__PenumsAssignment : ( rulePEnum ) ;
    public final void rule__Model__PenumsAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:372:1: ( ( rulePEnum ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:373:1: ( rulePEnum )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:373:1: ( rulePEnum )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:374:1: rulePEnum
            {
             before(grammarAccess.getModelAccess().getPenumsPEnumParserRuleCall_0()); 
            pushFollow(FOLLOW_rulePEnum_in_rule__Model__PenumsAssignment690);
            rulePEnum();

            state._fsp--;

             after(grammarAccess.getModelAccess().getPenumsPEnumParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__PenumsAssignment"


    // $ANTLR start "rule__PEnum__NameAssignment_1"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:383:1: rule__PEnum__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__PEnum__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:387:1: ( ( RULE_ID ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:388:1: ( RULE_ID )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:388:1: ( RULE_ID )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:389:1: RULE_ID
            {
             before(grammarAccess.getPEnumAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__PEnum__NameAssignment_1721); 
             after(grammarAccess.getPEnumAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__NameAssignment_1"


    // $ANTLR start "rule__PEnum__ElementsAssignment_3"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:398:1: rule__PEnum__ElementsAssignment_3 : ( rulePEnumElement ) ;
    public final void rule__PEnum__ElementsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:402:1: ( ( rulePEnumElement ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:403:1: ( rulePEnumElement )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:403:1: ( rulePEnumElement )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:404:1: rulePEnumElement
            {
             before(grammarAccess.getPEnumAccess().getElementsPEnumElementParserRuleCall_3_0()); 
            pushFollow(FOLLOW_rulePEnumElement_in_rule__PEnum__ElementsAssignment_3752);
            rulePEnumElement();

            state._fsp--;

             after(grammarAccess.getPEnumAccess().getElementsPEnumElementParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnum__ElementsAssignment_3"


    // $ANTLR start "rule__PEnumElement__NameAssignment_0"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:413:1: rule__PEnumElement__NameAssignment_0 : ( RULE_ID ) ;
    public final void rule__PEnumElement__NameAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:417:1: ( ( RULE_ID ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:418:1: ( RULE_ID )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:418:1: ( RULE_ID )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:419:1: RULE_ID
            {
             before(grammarAccess.getPEnumElementAccess().getNameIDTerminalRuleCall_0_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__PEnumElement__NameAssignment_0783); 
             after(grammarAccess.getPEnumElementAccess().getNameIDTerminalRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnumElement__NameAssignment_0"


    // $ANTLR start "rule__PEnumElement__AlternateTextAssignment_1"
    // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:428:1: rule__PEnumElement__AlternateTextAssignment_1 : ( RULE_STRING ) ;
    public final void rule__PEnumElement__AlternateTextAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:432:1: ( ( RULE_STRING ) )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:433:1: ( RULE_STRING )
            {
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:433:1: ( RULE_STRING )
            // ../org.xtext.example.penum.ui/src-gen/org/xtext/example/mydsl/ui/contentassist/antlr/internal/InternalPEnum.g:434:1: RULE_STRING
            {
             before(grammarAccess.getPEnumElementAccess().getAlternateTextSTRINGTerminalRuleCall_1_0()); 
            match(input,RULE_STRING,FOLLOW_RULE_STRING_in_rule__PEnumElement__AlternateTextAssignment_1814); 
             after(grammarAccess.getPEnumElementAccess().getAlternateTextSTRINGTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PEnumElement__AlternateTextAssignment_1"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleModel_in_entryRuleModel61 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleModel68 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Model__PenumsAssignment_in_ruleModel94 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_rulePEnum_in_entryRulePEnum122 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePEnum129 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnum__Group__0_in_rulePEnum155 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePEnumElement_in_entryRulePEnumElement182 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePEnumElement189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnumElement__Group__0_in_rulePEnumElement215 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnum__Group__0__Impl_in_rule__PEnum__Group__0249 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__PEnum__Group__1_in_rule__PEnum__Group__0252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_rule__PEnum__Group__0__Impl280 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnum__Group__1__Impl_in_rule__PEnum__Group__1311 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_rule__PEnum__Group__2_in_rule__PEnum__Group__1314 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnum__NameAssignment_1_in_rule__PEnum__Group__1__Impl341 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnum__Group__2__Impl_in_rule__PEnum__Group__2371 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_rule__PEnum__Group__3_in_rule__PEnum__Group__2374 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_12_in_rule__PEnum__Group__2__Impl402 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnum__Group__3__Impl_in_rule__PEnum__Group__3433 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_rule__PEnum__Group__4_in_rule__PEnum__Group__3436 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnum__ElementsAssignment_3_in_rule__PEnum__Group__3__Impl463 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_rule__PEnum__Group__4__Impl_in_rule__PEnum__Group__4494 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_rule__PEnum__Group__4__Impl522 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnumElement__Group__0__Impl_in_rule__PEnumElement__Group__0563 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_rule__PEnumElement__Group__1_in_rule__PEnumElement__Group__0566 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnumElement__NameAssignment_0_in_rule__PEnumElement__Group__0__Impl593 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnumElement__Group__1__Impl_in_rule__PEnumElement__Group__1623 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__PEnumElement__AlternateTextAssignment_1_in_rule__PEnumElement__Group__1__Impl650 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePEnum_in_rule__Model__PenumsAssignment690 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__PEnum__NameAssignment_1721 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePEnumElement_in_rule__PEnum__ElementsAssignment_3752 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__PEnumElement__NameAssignment_0783 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_STRING_in_rule__PEnumElement__AlternateTextAssignment_1814 = new BitSet(new long[]{0x0000000000000002L});

}